package de.itstall;

import de.itstall.model.Kontakt;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.Border;
import javafx.scene.layout.BorderStroke;
import javafx.scene.layout.BorderStrokeStyle;
import javafx.scene.layout.BorderWidths;
import javafx.scene.paint.Color;

public class TelefonbuchController {

    private Kontakt kontakt = new Kontakt();

    @FXML
    private TextField txtVorname;

    @FXML
    private TextField txtNachname;

    @FXML
    private TextField txtStrasse;

    @FXML
    private TextField txtHNr;

    @FXML
    private TextField txtPlz;

    @FXML
    private TextField txtOrt;

    @FXML
    private TextField txtTelefon;

    @FXML
    private Button btnNaviLinks;

    @FXML
    private Button btnNaviRechts;

    @FXML
    private Button btnNeuerEintrag;

    @FXML
    private Button btnLoeschen;

    @FXML
    void loeschen(ActionEvent event) {

    }

    @FXML
    void navWeiter(ActionEvent event) {

    }

    @FXML
    void navZurueck(ActionEvent event) {

    }

    @FXML
    void neuerEintrag(ActionEvent event) {

    }

    @FXML
    void initialize() {
        assert txtVorname != null : "fx:id=\"txtVorname\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert txtNachname != null : "fx:id=\"txtNachname\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert txtStrasse != null : "fx:id=\"txtStrasse\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert txtHNr != null : "fx:id=\"txtHNr\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert txtPlz != null : "fx:id=\"txtPlz\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert txtOrt != null : "fx:id=\"txtOrt\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert txtTelefon != null : "fx:id=\"txtTelefon\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert btnNaviLinks != null : "fx:id=\"btnNaviLinks\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert btnNaviRechts != null : "fx:id=\"btnNaviRechts\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert btnNeuerEintrag != null : "fx:id=\"btnNeuerEintrag\" was not injected: check your FXML file 'telefonbuch.fxml'.";
        assert btnLoeschen != null : "fx:id=\"btnLoeschen\" was not injected: check your FXML file 'telefonbuch.fxml'.";

        txtVorname.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setVorname(txtVorname.getText())) {
                    setFieldError(txtVorname, true);
                } else {
                    setFieldError(txtVorname, false);
                }
            }
        });

        txtNachname.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setNachname(txtNachname.getText())) {
                    setFieldError(txtNachname, true);
                } else {
                    setFieldError(txtNachname, false);
                }
            }
        });

        txtStrasse.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setStrasse(txtStrasse.getText())) {
                    setFieldError(txtStrasse, true);
                } else {
                    setFieldError(txtStrasse, false);
                }
            }
        });

        txtHNr.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setHausnummer(txtHNr.getText())) {
                    setFieldError(txtHNr, true);
                } else {
                    setFieldError(txtHNr, false);
                }
            }
        });

        txtPlz.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setPlz(txtPlz.getText())) {
                    setFieldError(txtPlz, true);
                } else {
                    setFieldError(txtPlz, false);
                }
            }
        });

        txtOrt.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setOrt(txtOrt.getText())) {
                    setFieldError(txtOrt, true);
                } else {
                    setFieldError(txtOrt, false);
                }
            }
        });

        txtTelefon.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
            if(!t1) {
                if(!kontakt.setTelefon(txtTelefon.getText())) {
                    setFieldError(txtTelefon, true);
                } else {
                    setFieldError(txtTelefon, false);
                }
            }
        });
    }

    public void setFieldError(TextField field, boolean set) {
        if(set) {
            field.setStyle("-fx-control-inner-background: #ff000040;");
        } else {
            field.setStyle("-fx-control-inner-background: WHITE;");
        }
    }
}
